# T2E ToolKit V1.1 instaler
#
#         created K.Ishibashi  22 Jan 1999
#         changed S.Nakagoshi  21 Jan 2003
#


##################################################################
# globalϐ̐錾
#

# global scope option is array value
variable option

##################################################################
# installCode -- 又
#      swdir  F SystemwalkerCXg[fBNg
#      tgdir  F CXg[fBNg
#      option F CXg[IvVtO
#
proc installCode { script_path swdir tgdir } {

	global option

	# swdir̃`FbN
	if { [file isdirectory ${swdir}/mpwalker.dm] == 0 } {
		puts stderr [file nativename ${swdir}/mpwalker.dm]
		puts stderr "Systemwalker Centric ManagerCXg[fBNg܂łB"
		exit 1
	}

	# tgdir̃`FbN
	if { [file isdirectory ${tgdir}] == 0 } {
		if { ${option(SILENT)} == 0 } {
			puts "CXg[fBNg\"[file nativename ${tgdir}]\"݂܂B"
			puts -nonewline "CXg[fBNg쐬܂H(Y/N) > "
			flush stdout
			gets stdin ans
			if { [regexp -- {^([yY]|[yY][eE][sS])$} ${ans}] == 0 } {
				puts stderr "T2Ec[Lbg̃CXg[𒆎~܂B"
				exit 1
			}
		}
		file mkdir ${tgdir}
		puts "fBNg쐬܂B"
	} else {
		set filelist [glob -nocomplain ${tgdir}/*]
		if { ${option(UPDATE)} == 0 && ${filelist} != "" } {
			puts stderr "CXg[fBNgł͂܂BB"
			puts stderr "t@Cړ܂͍폜ĂēxsĉB"
			puts stderr "T2Ec[Lbg̃CXg[𒆎~܂B"
			exit 1
		}
	}

	# MpCNapplCW[̃`FbN
	set update_module ${script_path}/update
	if { [file isdirectory ${update_module}] == 0 } {
		puts stderr [file nativename ${update_module}]
		puts stderr "Systemwalker Centric ManageȑCW[݂܂B"
		exit 1
	}

	if { ${tgdir} != [pwd] } {
		#t@C̃Rs[
		set cplist {doc ctl tcl}
		foreach name ${cplist} {
			puts "[file nativename ${name}]Rs[Ă܂B"
			copydir ${script_path}/${name} ${tgdir}
		}
	}

	# bax(batt@C̃ev[g)̕ϊ
	set result [glob ${script_path}/template/*.bax]

	foreach inname ${result} {
		# "template/XXXX.bax"XXXX܂ł擾
		set name [file rootname ${inname}]
		set outname [file tail ${name}.bat]

		puts "${outname}R}h쐬Ă܂B"
		set outfileid [open ${tgdir}/${outname} w]
		set infileid  [open ${inname}  r]
		while { [eof ${infileid}] == 0 } {
			gets ${infileid} record
			regsub -all "&&TG&&" ${record} [file nativename ${tgdir}] record
			regsub -all "&&SW&&" ${record} [file nativename ${swdir}] record
			puts ${outfileid} ${record}
		}
		close ${infileid}
		close ${outfileid}
	}

	# MpCNapplCW[̓Kp
	copydir ${update_module}/MpCNappl ${swdir}/mpwalker.dm
	puts "T2Ec[Lbg̃CXg[܂B"
}


# T2E ToolKit V1.0 instaler main
#
#         created K.Ishibashi  19 Jan 1999
#         changed S.Nakagoshi  21 Jan 2003
#

proc main { tgdir } {

	# get install script path
	set script_path [file join [file dirname [info script]]]

	# get Systemwalker install directory
	set hive HKEY_LOCAL_MACHINE
	set key SOFTWARE\\FUJITSU\\MpWalker\\CurrentVersion
	set name "DM PathName"
	set swdir ""
	catch {exec ${script_path}/ctl/t2egetreg ${hive} ${key} ${name}} swdir
	if { ${swdir} == "" } {
		puts stderr "Systemwalker Centric ManagerCXg[fBNg܂łB"
		exit 1
	}

	# change path separater
	set swdir [file join ${swdir}]
	set tgdir [file join ${tgdir}]

	installCode ${script_path} ${swdir} ${tgdir}
}

# T2E ToolKit V1.0 installer copydir
#
#         created S.Nakagoshi 25 Feb 2003
#
proc copydir { src dst } {
	if { [file isdirectory ${dst}] == 0 } {
		puts stderr "Rs[fBNg[file nativename ${dst}]܂B"
		return 1
	}
	if { [file isfile ${src}] } {
		file copy -force -- ${src} ${dst}
		return 0
	}
	if { [file isdirectory ${dst}/[file tail ${src}]] == 0 } {
		file copy -force -- ${src} ${dst}
		return 0
	}
	set filelist [glob -nocomplain -- ${src}/*]
	foreach name ${filelist} {
		copydir ${name} ${dst}/[file tail ${src}]
	}
	return 0
}

# T2E ToolKit V1.0 instaler
#
#         created K.Ishibashi  19 Jan 1999
#         changed S.Nakagoshi  21 Jan 2003
#


	set tgdir ""
	set SILENT 1
	set last_opt 0
	set option(SILENT) 0
	set option(UPDATE) 0

	# check parameter
	foreach param ${argv} {
		if { ${last_opt} } {
			set tgdir ${param}
			break
		}
		switch -regexp -- ${param} {
			{^--$} {
				# no more option
				set last_opt 1
			}
			{^[\-/][sS]$} {
				# silent install mode
				set option(SILENT) 1
			}
			{^[\-/][uU]$} {
				# update install mode
				set option(UPDATE) 1
			}
			default {
				# not option
				set tgdir ${param}
			}
		}
	}

	# check target direcotry
	if { ${tgdir} == "" } {
		puts stderr {command T2E_install_path}
		puts stderr "T2Ec[Lbg̃CXg[fBNgw肳Ă܂B"
		exit 1
	}

	main ${tgdir}

# EOF

